				     // Kapitel 11 - Programm 9 - ANWGER1.CPP

#include "iostream.h"



// Eine sehr einfache Klasse

class CForm

{

public:

   void ZeigeForm(void);

   virtual void Kopf(void) { cout << "Das ist eine Kopfzeile\n"; }

   virtual void Koerper(void) = 0;	// Rein virtuelle Funktion.

   virtual void Fusz(void) { cout << "Das ist die Fuzeile\n\n"; }

};





void CForm::ZeigeForm(void)

{

   Kopf();

   for (int Index = 0 ; Index < 3 ; Index++)

   {

	  Koerper();

   }

   Fusz();

}





// Diese Klasse berschreibt zwei der virtuellen Methoden der Basisklasse

class CMeineForm : public CForm

{

   void Koerper(void) { cout << "Das ist der neue Text\n"; }

   void Fusz(void) { cout << "Das ist eine neue Fuzeile\n"; }

};





int main()

{

// Die nchsten drei Code-Zeilen sind jetzt nicht mehr erlaubt, da CForm ein

//  abstrakter Datentyp ist und von diesem Typ kein Objekt erzeugt werden kann

//CForm *ErsteForm = new CForm;

//   ErsteForm->ZeigeForm();	   // Ein Aufruf an die Basisklasse

//   delete ErsteForm;



CForm *ErsteForm = new CMeineForm;	// Ein Objekt der abgeleiteten Klasse

   ErsteForm->ZeigeForm();		// Ein Aufruf an eine abgeileitete Klasse



   return 0;

}





// Ergebnis beim Ausfhren

//

// Das ist eine Kopfzeile

//	Das ist der neue Text

//	Das ist der neue Text

//	Das ist der neue Text

// Das ist eine neue Fuzeile

