					// Kapitel 9 - Programm 2 - MEHRVER2.CPP

#include <iostream.h>



class FahrenderLastwagen

{

protected:

   float Ladung;

   float Eigengewicht;

   float Verbrauch;

public:

   void Initialisiere(float L, float E, float EinVerbrauch) {

	    Ladung = L;

	    Eigengewicht = E;

	    Verbrauch = EinVerbrauch; };

   float Effizienz(void) {

	    return(Ladung / (Ladung + Eigengewicht)); };

   float KostenProTonne(float Dieselpreis) {

	    return(Dieselpreis / (Ladung / 1000.0)); };

   float KostenProGanzemTag(float Dieselpreis) {

	    return(8.0 * Dieselpreis * 75.0 / Verbrauch); };

};





class Fahrerin

{

protected:

   float Stundenlohn;

public:

   void Initialisiere(float Lohn) {Stundenlohn = Lohn; };

   float KostenProKM(void) {return(Stundenlohn / 75.0); } ;

   float KostenProGanzemTag(float Ueberstundenlohn) {

	    return(8.0 * Stundenlohn); };

};





class GefahrenerLaster : public FahrenderLastwagen, public Fahrerin

{

public:

   void InitialisiereAlle(float L, float E, float EinVerbrauch, float Lohn)

	    { Ladung = L;

		Eigengewicht = E;

		Verbrauch = EinVerbrauch;

		Stundenlohn = Lohn; };

   float KostenProGanzemTag(float Dieselpreis) {

		return(8.0 * Stundenlohn +

				8.0 * Dieselpreis * 75.0 / Verbrauch); };

};





int main()

{

GefahrenerLaster MercedesBMW;



   MercedesBMW.InitialisiereAlle(10000.0, 5400.0, 20.5, 20.0);



   cout << "Die Effizienz des BMW ist " <<

		 MercedesBMW.Effizienz() << "\n";



   cout << "Die Kosten fr Mercedes per km sind " <<

		 MercedesBMW.KostenProKM() << "\n";



   cout << "Die Kosten pro Tag fr den BMW sind " <<

		 MercedesBMW.FahrenderLastwagen::KostenProGanzemTag(1.25) <<

		 "\n";



   cout << "Die Kosten fr Mercedes pro Tag sind " <<

		 MercedesBMW.Fahrerin::KostenProGanzemTag(26.25) <<

		 "\n";



   cout << "Die Kosten, wenn Mercedes den BMW einen Tag fhrt, sind " <<

		 MercedesBMW.KostenProGanzemTag(1.25) <<

		 "\n";



   return 0;

}









// Ergebnis beim Ausfhren

//

// Die Effizienz des BMW ist 0.649351

// Die Kosten fr Mercedes per km sind 0.266667

// Die Kosten pro Tag fr den BMW sind 36.5854

// Die Kosten fr Mercedes pro Tag sind 160

// Die Kosten, wenn Mercedes den BMW einen Tag fhrt, sind 196.585

