					// Kapitel 6 - Programm 1 - OBJARRAY.CPP

#include <iostream.h>



class Box

{

   int Laenge;

   int Breite;

   static int ExtraDaten;	// Deklaration von ExtraDaten

public:

   Box(void);			//Konstruktor

   void Setze(int NeueLaenge, int NeueBreite);

   int HoleFlaeche(void);

   int HoleExtraDaten(void) {return ExtraDaten++;}

};





int Box::ExtraDaten;		// Definition von ExtraDaten





Box::Box(void)		//Implementation des Konstruktors

{

   Laenge = 8;

   Breite = 8;

   ExtraDaten = 1;

}





// Diese Methode setzt die Gre der Box auf die beiden Parameter

void Box::Setze(int NeueLaenge, int NeueBreite)

{

   Laenge = NeueLaenge;

   Breite = NeueBreite;

}





// Diese Methode berechnet den Flaecheninhalt einer Box und gibt ihn zurck

int Box::HoleFlaeche(void)

{

   return (Laenge * Breite);

}





int main()

{

Box Klein, Mittel, Grosz, Gruppe[4];		//Sieben Boxen



   Klein.Setze(5, 7);

   Grosz.Setze(15, 20);



   for (int Index = 1 ; Index < 4 ; Index++)	//Gruppe[0] verwendet Standardwerte

	Gruppe[Index].Setze(Index + 10, 10);



   cout << "Der Flcheninhalt der kleinen Box ist " << Klein.HoleFlaeche() << "\n";

   cout << "Der Flcheninhalt der mittleren Box ist " << Mittel.HoleFlaeche() << "\n";

   cout << "Der Flcheninhalt der groen Box ist " << Grosz.HoleFlaeche() << "\n";



   for (int Index = 0 ; Index < 4 ; Index++)

	cout << "Der Flaecheninhalt der Array Box ist " <<

						 Gruppe[Index].HoleFlaeche() << "\n";



   cout << "Der Wert von ExtraDaten ist " << Klein.HoleExtraDaten() << "\n";

   cout << "Der Wert von ExtraDaten ist " << Mittel.HoleExtraDaten() << "\n";

   cout << "Der Wert von ExtraDaten ist " << Grosz.HoleExtraDaten() << "\n";

   cout << "Der Wert von ExtraDaten ist " << Gruppe[0].HoleExtraDaten() << "\n";

   cout << "Der Wert von ExtraDaten ist " << Gruppe[3].HoleExtraDaten() << "\n";



   return 0;

}









// Ergebnis beim Ausfhren

//

// Der Flcheninhalt der kleinen Box ist 35

// Der Flcheninhalt der mittleren Box ist 64

// Der Flcheninhalt der groen Box ist 300

// Der Flaecheninhalt der Array Box ist 64

// Der Flaecheninhalt der Array Box ist 110

// Der Flaecheninhalt der Array Box ist 120

// Der Flaecheninhalt der Array Box ist 130

// Der Wert von ExtraDaten ist 1

// Der Wert von ExtraDaten ist 2

// Der Wert von ExtraDaten ist 3

// Der Wert von ExtraDaten ist 4

// Der Wert von ExtraDaten ist 5

