					// Kapitel 6 - Programm 3 - OBJINTZG.CPP

#include <iostream.h>



class Box

{

   int Laenge;

   int Breite;

   int *Zeiger;

public:

   Box(void);	    //Konstruktor

   void Setze(int NeueLaenge, int NeueBreite, int GespeicherterWert);

   int HoleFlaeche(void) {return Laenge * Breite;}  // Inline

   int HoleWert(void) {return *Zeiger;}		// Inline

   ~Box();		    //Destructor

};





Box::Box(void)	    //Implementation des Konstruktors

{

   Laenge = 8;

   Breite = 8;

   Zeiger = new int;

   *Zeiger = 112;

}





// Diese Methode setzt Laenge, Breite und Wert auf die Parameter

void Box::Setze(int NeueLaenge, int NeueBreite, int GespeicherterWert)

{

   Laenge = NeueLaenge;

   Breite = NeueBreite;

   *Zeiger = GespeicherterWert;

}





Box::~Box(void)	    //Destruktor

{

   Laenge = 0;

   Breite = 0;

   delete Zeiger;

}





int main()

{

Box Klein, Mittel, Grosz;	     //Drei Boxen



   Klein.Setze(5, 7, 177);

   Grosz.Setze(15, 20, 999);



   cout << "Die Flche der kleinen Box ist " << Klein.HoleFlaeche() << "\n";

   cout << "Die Flche der mittleren Box ist " << Mittel.HoleFlaeche() << "\n";

   cout << "Die Flche der groen Box ist " << Grosz.HoleFlaeche() << "\n";

   cout << "Der in der kleinen Box gespeicherte Wert ist " <<

							Klein.HoleWert() << "\n";

   cout << "Der in der mittleren Box gespeicherte Wert ist " <<

							Mittel.HoleWert() << "\n";

   cout << "Der in der groen Box gespeicherte Wert ist " <<

							Grosz.HoleWert() << "\n";



   return 0;

}









// Ergebnis beim Ausfhren

//

// Die Flche der kleinen Box ist 35

// Die Flche der mittleren Box ist 64

// Die Flche der groen Box ist 300

// Der in der kleinen Box gespeicherte Wert ist 177

// Der in der mittleren Box gespeicherte Wert ist 112

// Der in der groen Box gespeicherte Wert ist 999

