#include <iostream.h>

#include <string.h>

#include <conio.h>

#include "abflug.h"

#include "plan.h"

#include "ggstde.h"

#include "karte.h"

#include "ort.h"

#include "uhr.h"



extern Ort Toilette;

extern Ort Wartebereich;

extern Ort Gate1;

extern Ort Gate2;

extern Ort Gate3;

extern Ort Gate4;

extern Ort Flugzeug1;

extern Ort Flugzeug2;

extern Ort Flugzeug3;

extern Ort Flugzeug4;



extern Gegenstaende PersoenlicheGegenstaende;

extern Uhr Uhrzeit;

extern Woerter EingabeWoerter;

extern Karte Flughafen;



int WarAufToilette = FALSE;	// TRUE, wenn die Toilette aufgesucht wurde;

					//  berprft in AendereGates.



Plan::Plan(void)

{

   Flugnummer[0] = 222;

   Flugnummer[1] = 17;

   Flugnummer[2] = 141;

   Flugnummer[3] = 79;



   Destination[0] = new char[7];

   strcpy(Destination[0], "HAWAII");



   Destination[1] = new char[7];

   strcpy(Destination[1], "PARIS ");



   Destination[2] = new char[7];

   strcpy(Destination[2], "ROME  ");



   Destination[3] = new char[7];

   strcpy(Destination[3], "TAHITI");



   Abflugstunde[0] = 9;

   Abflugstunde[1] = 9;

   Abflugstunde[2] = 9;

   Abflugstunde[3] = 9;

   Abflugminute[0] = 19;

   Abflugminute[1] = 17;

   Abflugminute[2] = 16;

   Abflugminute[3] = 18;

   Gate[0] = &Gate1;

   Gate[1] = &Gate2;

   Gate[2] = &Gate3;

   Gate[3] = &Gate4;

   FluegeStehen = FALSE;

   GatesStehen = FALSE;

   MeinGate = 0;

}





void Plan::AendereFluege(void)

{

   if (!FluegeStehen)				// Bis Flge stehen,

	MeinGate = (MeinGate + 1) % 4;	//  whle nchsten Flug

							//  am nchsten Gate

}





void Plan::AendereGates(void)

{

int Temp;

char *TempPunkt;



   if (Flughafen.HoleMomentanenOrt() == &Toilette)

	WarAufToilette = TRUE;



   if ((Flughafen.HoleMomentanenOrt() ==

					   Gate[MeinGate]) && (!GatesStehen))

   {

	Temp		  = Flugnummer[0];

	Flugnummer[0] = Flugnummer[1];

	Flugnummer[1] = Flugnummer[2];

	Flugnummer[2] = Flugnummer[3];

	Flugnummer[3] = Temp;



	TempPunkt	   = Destination[0];

	Destination[0] = Destination[1];

	Destination[1] = Destination[2];

	Destination[2] = Destination[3];

	Destination[3] = TempPunkt;



	Temp		    = Abflugstunde[0];

	Abflugstunde[0] = Abflugstunde[1];

	Abflugstunde[1] = Abflugstunde[2];

	Abflugstunde[2] = Abflugstunde[3];

	Abflugstunde[3] = Temp;



	Temp		    = Abflugminute[0];

	Abflugminute[0] = Abflugminute[1];

	Abflugminute[1] = Abflugminute[2];

	Abflugminute[2] = Abflugminute[3];

	Abflugminute[3] = Temp;



	MeinGate = (MeinGate + 3) % 4;  // Zieh eins von MeinGate ab



	cout <<

	   "Man hrt ber die Lautsprecher eine (angenehme) Stimme: \"Alle"

	   " Gates\nwurden wegen schlechten Wetters gendert. Es wurden "

	   "keine Flge gecancelled.\"\n";



   }

}





					  // Das friert die Gateszuweisungen ein

void Plan::ZeigeFluege(Ort *Aufenthaltsort)

{

   if (Aufenthaltsort == &Wartebereich)

	GatesStehen = TRUE;



   for (int Index = 0 ; Index < 4 ; Index++)

   {

	cout << "Gate " << (Index + 1) << " - Flug " <<

		  Flugnummer[Index] << " - " <<

		  Destination[Index] << " - ";

	ZeigeZeit(Index);

   }

}





void Plan::GateNachricht(Ort *Aufenthaltsort)

{

int Index;



		  // Finde unser Gate und zeige Nachricht

   for (Index = 0;Index < 4;Index++)

	if (Aufenthaltsort == Gate[Index]) goto GateIstGefunden;



   return;	  // wenn kein Gate



   GateIstGefunden:

   cout << "Flug " << Flugnummer[Index] << // wenn Gate gefunden

		   " - " << Destination[Index] << " - ";

   ZeigeZeit(Index);

}





					     // Das friert den Flug der Spielerin ein

void Plan::ZeigeDestination(void)

{

	FluegeStehen = TRUE;



	cout << "Flug " << Flugnummer[MeinGate] << " - " <<

						   Destination[MeinGate] << " - ";

	ZeigeZeit(MeinGate);

}





void Plan::ZeigeZeit(int Index)

{

   if (Abflugminute[Index] < 10)

   {

	cout << Abflugstunde[Index] << ":0" <<

						Abflugminute[Index] << "\n";

   }

   else

   {

	cout << Abflugstunde[Index] << ":" <<

						Abflugminute[Index] << "\n";

   }

}





void Plan::UeberpruefeFlug(void)

{



   if ((Flughafen.HoleMomentanenOrt() == &Flugzeug1) ||

	   (Flughafen.HoleMomentanenOrt() == &Flugzeug2) ||

	     (Flughafen.HoleMomentanenOrt() == &Flugzeug3) ||

		 (Flughafen.HoleMomentanenOrt() == &Flugzeug4))

   {

							     // Wir brauchen ein Ticket

	if (!PersoenlicheGegenstaende.GegenstandHier(Ticket))

	{

	   cout <<

	   "Leider haben Sie kein Ticket, Sie werden als blinder\n"

	   "Passagier festgenommen und weinend aus dem Flugzeug\n"

	   "gestossen. Kein Urlaub fr Sie.\n";

	}



							  // Flugzeug 1 von Gate 1

	else if ((Flughafen.HoleMomentanenOrt() == &Flugzeug1) &&

									(MeinGate != 0))

	{

	   cout <<

	   "Leider sind sie bei Gate 1 und dieser Flug geht nach\n"

	   << Destination[0] << ". Vielleicht das nchste Mal.\n";

	}



							  // Flugzeug 2 von Gate 2

	else if ((Flughafen.HoleMomentanenOrt() == &Flugzeug2) &&

									(MeinGate != 1))

	{

	   cout <<

	   "Leider sind sie bei Gate 2 und dieser Flug geht nach\n"

	   << Destination[1] << ". Vielleicht das nchste Mal.\n";

	}



							  // Flugzeug 3 von Gate 3

	else if ((Flughafen.HoleMomentanenOrt() == &Flugzeug3) &&

									(MeinGate != 2))

	{

	   cout <<

	   "Leider sind sie bei Gate 3 und dieser Flug geht nach\n"

	   << Destination[2] << ". Vielleicht das nchste Mal.\n";

	}



							  // Flugzeug 4 von Gate 4

	else if ((Flughafen.HoleMomentanenOrt() == &Flugzeug4) &&

									(MeinGate != 3))

	{

	   cout <<

	   "Leider sind sie bei Gate 4 und dieser Flug geht nach\n"

	   << Destination[3] << ". Vielleicht das nchste Mal.\n";

	}



							     // Wir mssen pnktlich sein

	else if ((Uhrzeit.MomentaneStunde() > Abflugstunde[MeinGate]) ||

		   (Uhrzeit.MomentaneMinute() > Abflugminute[MeinGate]))

	{

	   cout <<

	   "Leider sind Sie fr Ihren Flug zu spt gekommen und\n"

	   "jetzt an Bord eines Frachtfliegers nach Wortort.Vielleicht\n"

	   "das nchste Mal.\n";

	}



							     // Wir brauchen Konfekt (jawohl!)

	else if (!PersoenlicheGegenstaende.GegenstandHier(Konfekt))

	{

	   cout <<

	   "Leider haben Sie nichts zum Essen mitgenommen und sind\n"

	   "auf halbem Weg verhungert.\n";

	}



						  // wir muten auf die Toilette

	else if (!WarAufToilette)

	{

	   cout <<

	   "Leider haben Sie vergessen, sich darum zu kmmern, worum\n"

	   "sogar der Kaiser sich selbst kmmern mute. Die Toiletten\n"

	   "im Flugzeug funktionieren nicht. Irgendwie sterben Sie\n"

	   "auf dem Weg zu Ihrem Ziel. Ursache ungeklrt.\n";

	}



				     // Eine erfolgreiche Reise durch den Flughafen...

	else

	{

	   cout <<

	   "Herzlichen Glckwunsch, Sie sind auf dem Weg in den wohl-\n"

	   "verdienten Urlaub. Im Flieger knnen Sie den Quellcode zu\n"

	   "diesem Programm studieren. Wenn Sie diesen nicht haben,\n"

	   "lesen Sie die Zeitung aus der Lobby und Sie werden eine\n"

	   "Adresse finden, wo Sie mehr Informationen erhalten.\n";

	}



	EingabeWoerter.StoppeSpiel();  // Beende Spiel

   }

}

