// Hier kmmern wir uns um alle Gate-Zuweisungen und den Flugplan.

// Der Flug der Spielerin wird bei jedem Zug bis sie das Ticket liest

// zufllig neu ausgewhlt. Wenn Sie das richtige Gate erreicht, befor

// sie den Monitor in der Wartehalle gesehen hat, (der Monitor am

// Schalter zhlt nicht), werden die Gates neu verteilt.

//

// Die Methode mti dem Namen PruefeFlug berprft alles Notwendige,

// damit alles richtig gemacht wurde, bevor die Spieler das Flugzeug

// betritt. Sie berprft nur, wenn die Spielerin in einem der

// Flugzeuge ist.



#ifndef PLAN_H

#define PLAN_H



#include "ort.h"



class Plan

{

   Ort *Gate[4];			// Die Namen der Gates

   int Flugnummer[4];		// Es gibt vier Flge, [0] bis [3]

   char *Destination[4];

   int Abflugstunde[4];

   int Abflugminute[4];

   int FluegeStehen;		// Die Flge stehen fest, sobald der Monitor

					//  in der Wartehalle gelesen wurde

   int GatesStehen;		// Steht fest, wenn Ticket gelesen

   int MeinGate;



public:



   Plan(void);

   void AendereFluege(void);

   void AendereGates(void);

   void ZeigeFluege(Ort *Aufenthaltsort);

   void GateNachricht(Ort *Aufenthaltsort);

   void ZeigeDestination(void);

   void ZeigeZeit(int Index);

   void UeberpruefeFlug(void);



};



#endif



