				     // Kapitel 9 - Programm 8 - SCHABL3.CPP

#include <stdio.h>

#include "datum.h"



const int MAXGROESZE = 128;



template<class JEDER_TYP>

class Stapel

{

   JEDER_TYP Array[MAXGROESZE];

   int StapelZeiger;

public:

   Stapel(void) { StapelZeiger = 0; };

   void Lege(JEDER_TYP EinDat) { Array[StapelZeiger++] = EinDat; };

   JEDER_TYP Nimm(void)    { return Array[--StapelZeiger]; };

   int Leer(void)       { return (StapelZeiger == 0); };

};



char Name[] = "Johann Gottlieb Fichte";



int main(void)

{

Stapel<char *> charStapel;

Stapel<Datum *> KlassenStapel;

Datum Kuh, Schwein, Hund, Extra;



   KlassenStapel.Lege(&Kuh);

   KlassenStapel.Lege(&Schwein);

   KlassenStapel.Lege(&Hund);

   KlassenStapel.Lege(&Extra);



   charStapel.Lege("Das ist Zeile 1");

   charStapel.Lege("Das ist die zweite Zeile");

   charStapel.Lege("Das ist die dritte Zeile");

   charStapel.Lege(Name);



   for (int Index = 0 ; Index < 4 ; Index++)

   {

	Extra = *KlassenStapel.Nimm();

	printf("Datum = %d %d %d\n", Extra.HoleMonat(),

					  Extra.HoleTag(), Extra.HoleJahr());

   };



   printf("\n     Zeichenketten\n");

   do

   {

	printf("%s\n", charStapel.Nimm());

   } while (!charStapel.Leer());



   return 0;

}





// Ergebnis beim Ausfhren



// Datum = 3 14 97

// Datum = 3 14 97

// Datum = 3 14 97

// Datum = 3 14 97

//

//	  Zeichenketten

// Johann Gottlieb Fichte

// Das ist die dritte Zeile

// Das ist die zweite Zeile

// Das ist Zeile 1

