					   // Kapitel 6 - Programm 16 - ZEIT.CPP



#include <stdio.h>	   // Fr die Funktion sprintf

#include <time.h>          // Fr die Funktionen time & localtime

#include "zeit.h"          // Fr den Kopf der Klasse





char Tageszeit::Format;  // Definition des statischen Elementes

char Tageszeit::AusZeichenkette[25];  // Definition der Zeichenkette





	   // Konstruktor - Setze aktuelle Zeit und

	   //               Format auf 1

Tageszeit::Tageszeit(void)

{

time_t ZeitDatum;

struct tm *AktuelleZeit;



   ZeitDatum    = time(NULL);

   AktuelleZeit = localtime(&ZeitDatum);

   Stunde	    = AktuelleZeit->tm_hour;

   Minute	    = AktuelleZeit->tm_min;

   Sekunde	    = AktuelleZeit->tm_sec;



   Format	    = 1;

}





	   // Setze die Zeit auf Eingabewerte

	   //  Rckgabe = 0 ---> Daten sind ok

	   //  Rckgabe = 1 ---> Etwas auerhalb des Limits

int Tageszeit::SetzeZeit(void)	   {return SetzeZeit(0, 0, 0); };

int Tageszeit::SetzeZeit(int H)	   {return SetzeZeit(H, 0, 0); };

int Tageszeit::SetzeZeit(int H, int M) {return SetzeZeit(H, M, 0); };

int Tageszeit::SetzeZeit(int EinStunde, int EinMinute, int EinSekunde)

{

int Fehler = 0;



   if (EinStunde < 0)

   {

	EinStunde = 0;

	Fehler = 1;

   }

   else if (EinStunde > 59)

   {

	EinStunde = 59;

	Fehler = 1;

   }

   Stunde = EinStunde;



   if (EinMinute < 0)

   {

	EinMinute = 0;

	Fehler = 1;

   }

   else if (EinMinute > 59)

   {

	EinMinute = 59;

	Fehler = 1;

   }

   Minute = EinMinute;



   if (EinSekunde < 0)

   {

	EinSekunde = 0;

	Fehler = 1;

   }

   else if (EinSekunde > 59)

   {

	EinSekunde = 59;

	Fehler = 1;

   }

   Sekunde = EinSekunde;



   return Fehler;

}







	   // Gib eine ASCII-Z Zeichenkette gem Ausgabeformat zurck

	   //  Format = 1    13:23:12

	   //  Format = 2    13:23

	   //  Format = 3     1:23 PM

char *Tageszeit::HoleFormatierteZeit(void)

{

   switch (Format)

   {

	case 2  : sprintf(AusZeichenkette, "%2d:%02d", Stunde, Minute);

		    break;



	case 3  : if (Stunde == 0)

			 sprintf(AusZeichenkette, "12:%02d AM", Minute);

		    else if (Stunde < 12)

			 sprintf(AusZeichenkette, "%2d:%02d AM", Stunde, Minute);

		    else if (Stunde == 12)

			 sprintf(AusZeichenkette, "12:%02d PM", Minute);

		    else

			 sprintf(AusZeichenkette, "%2d:%02d PM",

								 Stunde - 12, Minute);

		    break;



	case 1  : // weiter zum Standard, Standardausgabe ist also immer 1

	default : sprintf(AusZeichenkette, "%2d:%02d:%02d",

							     Stunde, Minute, Sekunde);

		    break;

   }



   return AusZeichenkette;

}

