					     // Kapitel 6 - Programm 15 - ZEIT.H



// Diese Klasse stellt wahrscheinlich das untere Limit fr eine

//  brauchbare Zeit-Klasse dar, ist aber eher als Illustration einer

//  Klasse gedacht denn als Alles-in-einem Klasse fr weiterfhrende

//  Verwendung. Sie knnen sich Ihre Klasse ganz nach Ihrem Gusto

//  zusammenstellen.



#ifndef ZEIT_H

#define ZEIT_H



class Tageszeit

{

protected:

   int Stunde;				// 0 bis 23

   int Minute;				// 0 bis 59

   int Sekunde;				// 0 bis 59

   static char Format;			// Format fr die Ausgabe

   static char AusZeichenkette[25]; // Zeichenkette fr Ausgabe



public:

	   // Konstruktor - Setze aktuelle Zeit und Format auf 1

   Tageszeit(void);

   Tageszeit(int H) {Stunde = H; Minute = 0; Sekunde = 0; };

   Tageszeit(int H, int M) {Stunde = H; Minute = M; Sekunde = 0; };

   Tageszeit(int H, int M, int S) {Stunde = H; Minute = M; Sekunde = S; };



	   // Setze die Zeit auf Eingabewerte

	   //  Rckgabe = 0 ---> Daten sind ok

	   //  Rckgabe = 1 ---> Etwas auerhalb des Limits

   int SetzeZeit(void);

   int SetzeZeit(int EinStunde);

   int SetzeZeit(int EinStunde, int EinMinute);

   int SetzeZeit(int EinStunde, int EinMinute, int EinSekunde);



	   // Whle Ausgabeformat

   void SetzeZeitFormat(int EinFormat) { Format = EinFormat; };



	   // Gib eine ASCII-Z Zeichenkette gem Ausgabeformat zurck

	   //  Format = 1    13:23:12

	   //  Format = 2    13:23

	   //  Format = 3     1:23 PM

   char *HoleFormatierteZeit(void);



};



#endif

