				     // Kapitel 6 - Programm 10 - AUTOMETH.CPP

#include <iostream.h>

#include <string.h>

#include <stdlib.h>



class Standards

{

   int Groesze;		   // Ein einfacher gespeicherter Wert

   char *Zeichenkette;	   // Ein Name fr den gespeicherten Wert

public:

	// Das berschreibt den Standardkonstruktor

   Standards(void);



	// Das berschreibt den Standard-Kopierkonstruktor

   Standards(Standards &EinObjekt);



	// Das berschreibt den Standard-Zuweisungskonstruktor

   Standards &operator=(Standards &EinObjekt);



	// Dieser Destruktor ist durch dynamischer Speicherbeschaffung notwendig

   ~Standards(void);



	// Und schlielich ein paar normale Methoden

   void SetzeDaten(int EinGroesze, char *EinZeichenkette);

   void HoleDaten(char *AusZeichenkette);

};



Standards::Standards(void)

{

   Groesze = 0;

   Zeichenkette = new char[2];

   strcpy(Zeichenkette, "");

}



Standards::Standards(Standards &EinObjekt)

{

   Groesze = EinObjekt.Groesze;

   Zeichenkette = new char[strlen(EinObjekt.Zeichenkette) + 1];

   strcpy(Zeichenkette, EinObjekt.Zeichenkette);

}



Standards &Standards::operator=(Standards &EinObjekt)

{

   delete [] Zeichenkette;

   Groesze = EinObjekt.Groesze;

   Zeichenkette = new char[strlen(EinObjekt.Zeichenkette) + 1];

   strcpy(Zeichenkette, EinObjekt.Zeichenkette);

   return *this;

}



Standards::~Standards(void)

{

   delete [] Zeichenkette;

}



void Standards::SetzeDaten(int EinGroesze, char *EinZeichenkette)

{

   Groesze = EinGroesze;

   delete [] Zeichenkette;

   Zeichenkette = new char[strlen(EinZeichenkette) + 1];

   strcpy(Zeichenkette, EinZeichenkette);

}







void Standards::HoleDaten(char *AusZeichenkette)

{

char Temp[10];



   strcpy(AusZeichenkette, Zeichenkette);

   strcat(AusZeichenkette, " = ");

   _itoa(Groesze, Temp, 10);

   strcat(AusZeichenkette, Temp);

}



int main()

{

char Buffer[80];

Standards MeineDaten;



   MeineDaten.SetzeDaten(8, "Hutgre");

   MeineDaten.HoleDaten(Buffer);

   cout << Buffer << "\n\n";



Standards MehrDaten(MeineDaten);

   MehrDaten.SetzeDaten(12, "Schuhgre");

   MeineDaten.HoleDaten(Buffer);

   cout << Buffer << "\n";

   MehrDaten.HoleDaten(Buffer);

   cout << Buffer << "\n\n";



   MeineDaten = MehrDaten;

   MeineDaten.HoleDaten(Buffer);

   cout << Buffer << "\n";

   MehrDaten.HoleDaten(Buffer);

   cout << Buffer << "\n";



   return 0;

}







// Ergebnis beim Ausfhren

//

// Hutgre = 8

//

// Hutgre = 8

// Schuhgre = 12

//

// Schuhgre = 12

// Schuhgre = 12

