					// Kapitel 9 - Programm 3 - MEHRVER3.CPP

#include <iostream.h>



class FahrenderLastwagen

{

protected:

   float Ladung;

   float Gewicht;

   float Verbrauch;

public:

   void Initialisiere(float L, float G, float EinVerbrauch) {

	    Ladung = L;

	    Gewicht = G;

	    Verbrauch = EinVerbrauch; };

   float Effizienz(void) {

	    return(Ladung / (Ladung + Gewicht)); };

   float KostenProTonne(float Dieselpreis) {

	    return(Dieselpreis / (Ladung / 1000.0)); };

};





class Fahrerin

{

protected:

   float Stundenlohn;

   float Gewicht;

public:

   void Initialisiere(float Lohn, float EinGewicht) {

	     Stundenlohn = Lohn;

	     Gewicht = EinGewicht; };

   float KostenProKM(void) {return(Stundenlohn / 75.0); } ;

   float GewichtDerFahrerin(void) {return(Gewicht); };

};





class GefahrenerLaster : public FahrenderLastwagen, public Fahrerin

{

public:

   void InitialisiereAlle(float L, float G, float EinVerbrauch, float Lohn)

	    { Ladung = L;

		FahrenderLastwagen::Gewicht = G;

		Verbrauch = EinVerbrauch;

		Stundenlohn = Lohn; };

   float KostenProGanzemTag(float Dieselpreis) {

		return(8.0 * Stundenlohn +

				8.0 * Dieselpreis * 75.0 / Verbrauch); };

   float Gesamtgewicht(void) {

		return(FahrenderLastwagen::Gewicht + Fahrerin::Gewicht); };

};





int main()

{

GefahrenerLaster MercedesBMW;



   MercedesBMW.InitialisiereAlle(10000.0, 5400.0, 20.5, 20.0);

   MercedesBMW.Fahrerin::Initialisiere(23.50, 64.0);



   cout << "Die Effizienz des BMW ist " <<

		 MercedesBMW.Effizienz() << "\n";



   cout << "Die Kosten fr Mercedes per km sind " <<

		 MercedesBMW.KostenProKM() << "\n";



   cout << "Die Kosten, wenn Mercedes den BMW einen Tag fhrt, sind " <<

		 MercedesBMW.KostenProGanzemTag(1.25) << "\n";



   cout << "Das Gesamtgewicht ist " << MercedesBMW.Gesamtgewicht() <<

		 "kg \n";



   return 0;

}









// Ergebnis beim Ausfhren

//

// Die Effizienz des BMW ist 0.649351

// Die Kosten fr Mercedes per km sind 0.313333

// Die Kosten, wenn Mercedes den BMW einen Tag fhrt, sind 224.585

// Das Gesamtgewicht ist 5464 kg

