					 // Kapitel 6 - Programm 5 - OBJLISTE.CPP

#include <iostream.h>



class Box

{

   int Laenge;

   int Breite;

   Box *AndereBox;

public:

   Box(void);		  //Konstruktor

   void Setze(int NeueLaenge, int NeueBreite);

   int HoleFlaeche(void);

   void ZeigeAufNaechste(Box *ZeigeDahin);

   Box *HoleNaechste(void);

};





Box::Box(void)	    //Implementation des Konstruktors

{

   Laenge = 8;

   Breite = 8;

   AndereBox = NULL;

}





// Diese Methode setzt die Gre der Box auf die Parameter

void Box::Setze(int NeueLaenge, int NeueBreite)

{

   Laenge = NeueLaenge;

   Breite = NeueBreite;

}





// Diese Methode berechnet den Flcheninhalt der Box und gibt ihn zurck

int Box::HoleFlaeche(void)

{

   return (Laenge * Breite);

}





// Diese Methode lt den Zeiger auf den Parameter zeigen

void Box::ZeigeAufNaechste(Box *ZeigeDahin)

{

   AndereBox = ZeigeDahin;

}





// Diese Methode gibt die Box, auf die die momentane zeigt, zurck

Box *Box::HoleNaechste(void)

{

   return AndereBox;

}





int main()

{

Box Klein, Mittel, Grosz;	     //Drei Boxen

Box *BoxZeiger;			     //Ein Zeiger auf eine Box



   Klein.Setze(5, 7);

   Grosz.Setze(15, 20);



   cout << "Der Flcheninhalt der kleinen Box ist " << Klein.HoleFlaeche() << "\n";

   cout << "Der Flcheninhalt der mittleren Box ist " << Mittel.HoleFlaeche() << "\n";

   cout << "Der Flcheninhlat der groen Box ist " << Grosz.HoleFlaeche() << "\n";



   Klein.ZeigeAufNaechste(&Mittel);

   Mittel.ZeigeAufNaechste(&Grosz);



   BoxZeiger = &Klein;

   BoxZeiger = BoxZeiger->HoleNaechste();

   cout << "Der Flcheninhalt der Box, auf die gezeigt wird, ist " <<

					    BoxZeiger->HoleFlaeche() << "\n";



   return 0;

}









// Ergebnis beim Ausfhren

//

// Der Flcheninhalt der kleinen Box ist 35

// Der Flcheninhalt der mittleren Box ist 64

// Der Flcheninhalt der groen Box ist 300

// Der Flcheninhalt der Box, auf die gezeigt wird, ist 64

