					 // Kapitel 6 - Programm 6 - OBJVERB.CPP

#include <iostream.h>



class Box

{

   int Laenge;

   int Breite;

   Box *AndereBox;

public:

   Box(void);		  //Konstruktor

   void Setze(int NeueLaenge, int NeueBreite);

   int HoleFlaeche(void);

   void ZeigeAufNaechste(Box *ZeigeDahin);

   Box *HoleNaechste(void);

};





Box::Box(void)	    //Implementation des Konstruktors

{

   Laenge = 8;

   Breite = 8;

   AndereBox = NULL;

}





// Diese Methode setzt die Gre der Box auf die Parameter

void Box::Setze(int NeueLaenge, int NeueBreite)

{

   Laenge = NeueLaenge;

   Breite = NeueBreite;

}





// Diese Methode berechnet den Flcheninhalt der Box und gibt ihn zurck

int Box::HoleFlaeche(void)

{

   return (Laenge * Breite);

}





// Diese Methode lt den Zeiger auf den Parameter zeigen

void Box::ZeigeAufNaechste(Box *ZeigeDahin)

{

   AndereBox = ZeigeDahin;

}





// Diese Methode gibt die Box, auf die die momentane zeigt, zurck

Box *Box::HoleNaechste(void)

{

   return AndereBox;

}





int main()

{

Box *Start = NULL;    // Zeigt immer auf den Beginn der Liste

Box *Temp;		    // Arbeitstier

Box *BoxZeiger;	    // Fr das Erzeugen von Boxen



							 // Erzeuge die Liste

   for (int Index = 0 ; Index < 10 ; Index++)

   {

	BoxZeiger = new Box;

	BoxZeiger->Setze(Index + 1, Index + 3);

	if (Start == NULL)

	{

	   Start = BoxZeiger;		     // Erstes Element in der Liste

	}

	else

	{

	   Temp->ZeigeAufNaechste(BoxZeiger); // Zustzliches Element

	}

	Temp = BoxZeiger;

   }



							 // Gib die Liste aus

   Temp = Start;

   do

   {

	cout << "Der Flcheninhalt ist " << Temp->HoleFlaeche() << "\n";

	Temp = Temp->HoleNaechste();

   } while (Temp != NULL);



							 // Lsche die Liste

   Temp = Start;

   do

   {

	Temp = Temp->HoleNaechste();

	delete Start;

	Start = Temp;

   } while (Temp != NULL);



   return 0;

}









// Ergebnis beim Ausfhren

//

// Der Flcheninhalt ist 3

// Der Flcheninhalt ist 8

// Der Flcheninhalt ist 15

// Der Flcheninhalt ist 24

// Der Flcheninhalt ist 35

// Der Flcheninhalt ist 48

// Der Flcheninhalt ist 63

// Der Flcheninhalt ist 80

// Der Flcheninhalt ist 99

// Der Flcheninhalt ist 120

